<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.18.2.1 $
 * $Author: tora60 $
 * $Date: 2010/10/03 09:39:52 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen("Authorisation 'radminsuper' is required!");
    die();
}

define('CAPTCHACONFIGSFILE', PMX_SYSTEM_DIR . DS . 'captcha/settings.php');

/* Speichern der Captcha Einstellungen */
function CaptchaConfigSave()
{
    $values = array('passphraselenght' => (intval($_POST['passphraselenght']) > 0) ? intval($_POST['passphraselenght']): 5,
        'charstouse' => (empty($_POST['charstouse'])) ? '23456789abcdfghjkmnpqrstvwxABCDEFGHJKLMNPRSTUVWXYZ' : preg_replace('#[^0-9a-zA-Z]#', '', $_POST['charstouse']),
        'casesensitive' => (empty($_POST['casesensitive'])) ? 0 : 1,
        'imagewidth' => (intval($_POST['imagewidth']) < 20) ? 200 : $_POST['imagewidth'],
        'imageheight' => (intval($_POST['imageheight']) < 20) ? 100 : $_POST['imageheight'],
        'fontsize' => (intval($_POST['fontsize']) < 20) ? 24 : $_POST['fontsize'],
        'bgintensity' => intval($_POST['bgintensity']),
        'bgfonttype' => (intval($_POST['bgfonttype']) < 1) ? 1 : $_POST['bgfonttype'],
        'scratchamount' => intval($_POST['scratchamount']),
        'filter' => (empty($_POST['filter'])) ? 0 : 1,
        'filtertype' => (empty($_POST['filtertype']) || !preg_match('#^(Wavy|Bubbly|Breaktype)$#', $_POST['filtertype'])) ? 'Bubbly' : $_POST['filtertype'],
        'scratches' => (empty($_POST['scratches'])) ? 0 : 1,
        'addagrid' => (empty($_POST['addagrid'])) ? 0 : 1,
        'addhorizontallines' => (empty($_POST['addhorizontallines'])) ? 0 : 1,
        'useRandomColors' => (empty($_POST['useRandomColors'])) ? 0 : 1,
        'minsize' => (intval($_POST['minsize']) >= 10) ? $_POST['minsize']: 10,
        'angle' => intval($_POST['angle']),
        'captchauseron' => (empty($_POST['captchauseron'])) ? 0 : 1,
        'feedbackon' => (empty($_POST['feedbackon'])) ? 0 : 1,
        'faqon' => (empty($_POST['faqon'])) ? 0 : 1,
        'downloadson' => (empty($_POST['downloadson'])) ? 0 : 1,
        'weblinkson' => (empty($_POST['weblinkson'])) ? 0 : 1,
        'guestbookon' => (empty($_POST['guestbookon'])) ? 0 : 1,
        'newson' => (empty($_POST['newson'])) ? 0 : 1,
        'newsletteron' => (empty($_POST['newsletteron'])) ? 0 : 1,
        'reviewson' => (empty($_POST['reviewson'])) ? 0 : 1,
        'registrationon' => (empty($_POST['registrationon'])) ? 0 : 1,
        'recommendon' => (empty($_POST['recommendon'])) ? 0 : 1,
        'commentson' => (empty($_POST['commentson'])) ? 0 : 1,
        );

    foreach ($values as $key => $value) {
        $content[] = '$' . $key . ' = \'' . $value . '\'; ';
    }

    $content = "<?php
/**
 * pragmaMx - Web Content Management System
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 */
defined('mxMainFileLoaded') or die('access denied');
" . implode("\n", $content) . "
?>";

    @chmod(CAPTCHACONFIGSFILE, 0666);
    $file = @fopen(CAPTCHACONFIGSFILE, 'w');
    $ok = @fwrite($file, $content);
    @fclose($file);
    @chmod(CAPTCHACONFIGSFILE, 0644);

    /* alles ok > redirect */
    if ($ok) {
        mxRedirect('admin.php?op=captcha', _ADMIN_SETTINGSAVED, 1);
        return;
    }
    /* error > exit */
    mxErrorScreen(_ADMIN_SETTINGNOSAVED, '', true);
    return;
}

function CaptchaSettings()
{
    if (@!include(CAPTCHACONFIGSFILE)) {
        // Konfigurationsfallback...
        $passphraselenght = '4';
        $charstouse = '23456789abcdfghjkmnpqrstvwxABCDEFGHJKLMNPRSTUVWXYZ';
        $casesensitive = '0';
        $imagewidth = '140';
        $imageheight = '40';
        $fontsize = '24';
        $bgintensity = '40';
        $bgfonttype = '3';
        $scratchamount = '30';
        $filter = '0';
        $filtertype = 'Wavy';
        $scratches = '1';
        $addagrid = '1';
        $addhorizontallines = '1';
        $useRandomColors = '1';
        $minsize = '24';
        $angle = '15';
        $captchauseron = '0';
        $feedbackon = '1';
        $faqon = '1';
        $downloadson = '1';
        $weblinkson = '1';
        $guestbookon = '1';
        $newson = '1';
        $newsletteron = '1';
        $reviewson = '1';
        $registrationon = '0';
        $recommendon = '1';
        $commentson = '1';
    }

    if (@file_exists(PMX_SYSTEM_DIR . DS . 'captcha/language/lang-' . $GLOBALS['currentlang'] . '.php')) {
        include_once(PMX_SYSTEM_DIR . DS . 'captcha/language/lang-' . $GLOBALS['currentlang'] . '.php');
    } else {
        include_once(PMX_SYSTEM_DIR . DS . 'captcha/language/lang-german.php');
    }

    include('header.php');
    // Javascript fuer Captcha-reload
    include(PMX_SYSTEM_DIR . DS . 'captcha/captcha_java.php');
    GraphicAdmin();
    title(_CAPTCHATITLE);

    $check = CaptchaCheck();
    if ($check !== true) {
        openTableAl() ?>
        <h3><?php echo _CAPTCHAERR ?></h3>
        <p class="content"><?php echo $check ?></p>
        <?php
        closeTableAl();
    }
    OpenTable();
    $sel = ' checked="checked"';

    ?>
<fieldset><legend><?php echo _CAPTCHASETTINGS ?></legend>
<form action="admin.php?op=captcha" method="post">

<table width="100%">
<tr>
  <td><b><?php echo _DATESAMPLE ?></b></td>
  <td>
    <?php echo mxCreateImage(PMX_SYSTEM_PATH . 'captcha/captchaimg.php?' . md5(crypt(uniqid(''))), '', 0, 'id="captchaimage"', 0, 1) ?><br /><br />
    <input type="button" value="<?php echo _CAPTCHARELOAD ?>" onclick="do_reload(); return false;">
  </td>
</tr>
<tr>
  <td colspan="2"><hr /><br /></td>
</tr>

<tr>
  <td><?php echo _CAPTCHAIMAGEWIDTH ?>:</td>
  <td><input type="text" name="imagewidth" size="12" value="<?php echo $imagewidth ?>"></td>
</tr>
<tr>
  <td><?php echo _CAPTCHAIMAGEHEIGHT ?>:</td>
  <td><input type="text" name="imageheight" size="12" value="<?php echo $imageheight ?>"></td>
</tr>

<tr>
  <td width="41%"><?php echo _CAPTCHAPASSPHRASELENGHT ?>:</td>
  <td width="59%"><input type="text" name="passphraselenght" size="12" value="<?php echo $passphraselenght ?>"></td>
</tr>
<tr>
  <td><?php echo _CAPTCHACHARSTOUSE ?>:</td>
  <td><textarea name="charstouse" cols="30" rows="2"><?php echo chunk_split($charstouse, 25) ?></textarea></td>
</tr>
<tr>
  <td><?php echo _CAPTCHACHARCASESEN ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($casesensitive) ? $sel : '' ?> name="casesensitive"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($casesensitive) ? '' : $sel ?> name="casesensitive"><?php echo _NO ?>
  </td>
</tr>

<tr>
  <td><?php echo _CAPTCHAFONTSIZE ?>:</td>
  <td><input type="text" name="fontsize" size="12" value="<?php echo $fontsize ?>"></td>
</tr>
<tr>
  <td><?php echo _CAPTCHARANDOMCOLOR ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($useRandomColors) ? $sel : '' ?> name="useRandomColors"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($useRandomColors) ? '' : $sel ?> name="useRandomColors"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAANGLE ?>:</td>
  <td><input type="text" name="angle" size="12" value="<?php echo $angle ?>"></td>
</tr>

<tr>
  <td><?php echo _CAPTCHAFILTER ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($filter) ? $sel : '' ?> name="filter"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($filter) ? '' : $sel ?> name="filter"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAFILTERTYPE ?></td>
  <td><select name="filtertype" size="1">
      <option <?php echo ($filtertype == 'Wavy') ? ' selected="selected"' : '' ?> value="Wavy">Wavy</option>
      <option <?php echo ($filtertype == 'Bubbly') ? ' selected="selected"' : '' ?> value="Bubbly">Bubbly</option>
      <option <?php echo ($filtertype == 'Breaktype') ? ' selected="selected"' : '' ?> value="Breaktype">Breaktype</option>
    </select></td>
</tr>


<tr>
  <td><?php echo _CAPTCHABGINTENSITY ?>:</td>
  <td><input type="text" name="bgintensity" size="12" value="<?php echo $bgintensity ?>"></td>
</tr>
<tr>
  <td><?php echo _CAPTCHABGFONTTYPE ?>:</td>
  <td><input type="text" name="bgfonttype" size="12" value="<?php echo $bgfonttype ?>"></td>
</tr>

<tr>
  <td><?php echo _CAPTCHAADDHORLINES ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($addhorizontallines) ? $sel : '' ?> name="addhorizontallines"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($addhorizontallines) ? '' : $sel ?> name="addhorizontallines"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHASCRATCHES ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($scratches) ? $sel : '' ?> name="scratches"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($scratches) ? '' : $sel ?> name="scratches"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHASCRATCHAMOUNT ?>:</td>
  <td><input type="text" name="scratchamount" size="12" value="<?php echo $scratchamount ?>"></td>
</tr>


<tr>
  <td><?php echo _CAPTCHAADDAGRID ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($addagrid) ? $sel : '' ?> name="addagrid"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($addagrid) ? '' : $sel ?> name="addagrid"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAMINSIZE ?>:</td>
  <td><input type="text" name="minsize" size="12" value="<?php echo $minsize ?>"></td>
</tr>

<tr>
  <td colspan="2"><hr /></td>
</tr>
<tr>
  <td><?php echo _CAPTCHAUSERON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($captchauseron) ? $sel : '' ?> name="captchauseron"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($captchauseron) ? '' : $sel ?> name="captchauseron"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td colspan="2"><hr /></td>
</tr>
<tr>
  <td><?php echo _CAPTCHAFEEDBACKON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($feedbackon) ? $sel : '' ?> name="feedbackon"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($feedbackon) ? '' : $sel ?> name="feedbackon"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAFAQON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($faqon) ? $sel : '' ?> name="faqon"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($faqon) ? '' : $sel ?> name="faqon"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAWEBLINKSON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($weblinkson) ? $sel : '' ?> name="weblinkson"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($weblinkson) ? '' : $sel ?> name="weblinkson"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHADOWNLOADSON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($downloadson) ? $sel : '' ?> name="downloadson"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($downloadson) ? '' : $sel ?> name="downloadson"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHANEWSON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($newson) ? $sel : '' ?> name="newson"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($newson) ? '' : $sel ?> name="newson"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHANEWSLETTERON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($newsletteron) ? $sel : '' ?> name="newsletteron"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($newsletteron) ? '' : $sel ?> name="newsletteron"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAGUESTBOOKON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($guestbookon) ? $sel : '' ?> name="guestbookon"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($guestbookon) ? '' : $sel ?> name="guestbookon"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAREVIEWSON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($reviewson) ? $sel : '' ?> name="reviewson"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($reviewson) ? '' : $sel ?> name="reviewson"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHARECOMMENDON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($recommendon) ? $sel : '' ?> name="recommendon"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($recommendon) ? '' : $sel ?> name="recommendon"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHACOMMENTSON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($commentson) ? $sel : '' ?> name="commentson"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($commentson) ? '' : $sel ?> name="commentson"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td><?php echo _CAPTCHAREGISTRATIONON ?></td>
  <td>
    <input type="radio" value="1"<?php echo ($registrationon) ? $sel : '' ?> name="registrationon"><?php echo _YES ?>
    <input type="radio" value="0"<?php echo ($registrationon) ? '' : $sel ?> name="registrationon"><?php echo _NO ?>
  </td>
</tr>
<tr>
  <td colspan="2"><hr /><br /></td>
</tr>
<tr>
  <td colspan="2" align="center">
    <input type="hidden" name="op" value="CaptchaConfigSave">
    <input type="submit" value="<?php echo _CAPTCHASAVESETTINGS ?>">
  </td>
</tr>
</table>
</form>
</fieldset>
<?php
    CloseTable();
    include("footer.php");
}

function CaptchaCheck()
{
    if (!function_exists('gd_info') || !function_exists('imagefontwidth') || !function_exists('imagecolorallocate') || !function_exists('imagestring') || !function_exists('imagejpeg')) {
        return _CAPTCHAERR_MISSINGGD;
    }
    if (!function_exists('imageftbbox') || !function_exists('imagettftext')) {
        return _CAPTCHAERR_FALSEFT;
    }
    $gd_info = gd_info();
    if (!is_array($gd_info) || !isset($gd_info['GD Version'])) {
        return _CAPTCHAERR_FALSEGD;
    }
    $gd_info['GD_Version'] = @preg_replace('#[^0-9.]#', '', $gd_info['GD Version']);
    if (version_compare($gd_info['GD_Version'], '2.0', '<')) {
        return _CAPTCHAERR_FALSEGD;
    }
    // Ab PHP 5.3.0: $gd_info['JPEG Support'] !!
    if (empty($gd_info['JPG Support']) && empty($gd_info['JPEG Support'])) {
        return _CAPTCHAERR_NOJPG;
    }
    if (!$gd_info['FreeType Support'] || $gd_info['FreeType Linkage'] != 'with freetype') {
        return _CAPTCHAERR_MISSINGFT;
    }
    return true;
}

switch ($op) {
    case "CaptchaConfigSave":
        CaptchaConfigSave();
        break;
    default :
        CaptchaSettings();
        break;
}

?>
